OCC.Core.StdSelect module

StdSelect module, see official documentation at https://www.opencascade.com/doc/occt-7.4.0/refman/html/package_stdselect.html

class StdSelect_BRepOwner(*args)

Bases: OCC.Core.SelectMgr.SelectMgr_EntityOwner

  • Constructs an owner specification framework defined by the priority aPriority.
    param aPriority

    type aPriority

    int

    rtype

    None* Constructs an owner specification framework defined by the shape aShape and the priority aPriority. aShape and aPriority are stored in this framework. If more than one owner are detected during dynamic selection, the one with the highest priority is the one stored.

    param aShape

    type aShape

    TopoDS_Shape

    param aPriority

    default value is 0

    type aPriority

    int

    param ComesFromDecomposition

    default value is Standard_False

    type ComesFromDecomposition

    bool

    rtype

    None* Constructs an owner specification framework defined by the shape aShape, the selectable object theOrigin and the priority aPriority. aShape, theOrigin and aPriority are stored in this framework. If more than one owner are detected during dynamic selection, the one with the highest priority is the one stored.

    param aShape

    type aShape

    TopoDS_Shape

    param theOrigin

    type theOrigin

    SelectMgr_SelectableObject

    param aPriority

    default value is 0

    type aPriority

    int

    param FromDecomposition

    default value is Standard_False

    type FromDecomposition

    bool

    rtype

    None

Clear()
  • Clears the presentation manager object aPM of all shapes with the selection mode aMode.
    param aPM

    type aPM

    PrsMgr_PresentationManager

    param aMode

    default value is 0

    type aMode

    int

    rtype

    void

static DownCast(t)
HasHilightMode()
  • Returns true if this framework has a highlight mode defined for it.
    rtype

    bool

HasShape()
  • returns False if no shape was set
    rtype

    bool

HilightMode()
  • Returns the highlight mode for this framework. This defines the type of display used to highlight the owner of the shape when it is detected by the selector. The default type of display is wireframe, defined by the index 0.
    rtype

    int

IsHilighted()
  • Returns true if an object with the selection mode aMode is highlighted in the presentation manager aPM.
    param aPM

    type aPM

    PrsMgr_PresentationManager

    param aMode

    default value is 0

    type aMode

    int

    rtype

    bool

ResetHilightMode()
  • Resets the higlight mode for this framework. This defines the type of display used to highlight the owner of the shape when it is detected by the selector. The default type of display is wireframe, defined by the index 0.
    rtype

    None

SetHilightMode()
  • Sets the highlight mode for this framework. This defines the type of display used to highlight the owner of the shape when it is detected by the selector. The default type of display is wireframe, defined by the index 0.
    param theMode

    type theMode

    int

    rtype

    None

SetLocation()
Parameters

aLoc

type aLoc

TopLoc_Location

rtype

void

Shape()
  • Returns the shape.
    rtype

    TopoDS_Shape

Unhilight()
  • Removes highlighting from the type of shape identified the selection mode aMode in the presentation manager aPM.
    param aPM

    type aPM

    PrsMgr_PresentationManager

    param aMode

    default value is 0

    type aMode

    int

    rtype

    void

UpdateHighlightTrsf()
  • Implements immediate application of location transformation of parent object to dynamic highlight structure
    param theViewer

    type theViewer

    V3d_Viewer

    param theManager

    type theManager

    PrsMgr_PresentationManager3d

    param theDispMode

    type theDispMode

    int

    rtype

    void

property thisown

The membership flag

class StdSelect_BRepSelectionTool

Bases: object

static ComputeSensitive()
  • Computes the sensitive primitives, stores them in the SelectMgr_Selection object, and returns this object. @param theShape shape to compute sensitive entities @param theOwner selectable owner object @param theSelection selection to append new sensitive entities @param theDeflection linear deflection @param theDeflAngle angular deflection @param theNbPOnEdge sensitivity parameters for edges and wires @param theMaxiParam sensitivity parameters for infinite objects (the default value is 500) @param theAutoTriang flag to compute triangulation for the faces which have none
    param theShape

    type theShape

    TopoDS_Shape

    param theOwner

    type theOwner

    SelectMgr_EntityOwner

    param theSelection

    type theSelection

    SelectMgr_Selection

    param theDeflection

    type theDeflection

    float

    param theDeflAngle

    type theDeflAngle

    float

    param theNbPOnEdge

    type theNbPOnEdge

    int

    param theMaxiParam

    type theMaxiParam

    float

    param theAutoTriang

    default value is Standard_True

    type theAutoTriang

    bool

    rtype

    void

static GetEdgeSensitive()
  • Create a sensitive edge or sensitive wire. @param theShape either TopoDS_Edge or TopoDS_Wire to compute sensitive entities @param theOwner selectable owner object @param theSelection selection to append new sensitive entities @param theDeflection linear deflection @param theDeviationAngle angular deflection @param theNbPOnEdge sensitivity parameters @param theMaxiParam sensitivity parameters
    param theShape

    type theShape

    TopoDS_Shape

    param theOwner

    type theOwner

    SelectMgr_EntityOwner

    param theSelection

    type theSelection

    SelectMgr_Selection

    param theDeflection

    type theDeflection

    float

    param theDeviationAngle

    type theDeviationAngle

    float

    param theNbPOnEdge

    type theNbPOnEdge

    int

    param theMaxiParam

    type theMaxiParam

    float

    param theSensitive

    type theSensitive

    Select3D_SensitiveEntity

    rtype

    void

static GetSensitiveForFace()
  • Creates the 3D sensitive entities for Face selection. @param theFace face to compute sensitive entities @param theOwner selectable owner object @param theOutList output result list to append created entities @param theAutoTriang obsolete flag (has no effect) @param theNbPOnEdge sensitivity parameters @param theMaxiParam sensitivity parameters @param theInteriorFlag flag indicating that face interior (True) or face boundary (False) should be selectable
    param theFace

    type theFace

    TopoDS_Face

    param theOwner

    type theOwner

    SelectMgr_EntityOwner

    param theOutList

    type theOutList

    Select3D_EntitySequence

    param theAutoTriang

    default value is Standard_True

    type theAutoTriang

    bool

    param theNbPOnEdge

    default value is 9

    type theNbPOnEdge

    int

    param theMaxiParam

    default value is 500

    type theMaxiParam

    float

    param theInteriorFlag

    default value is Standard_True

    type theInteriorFlag

    bool

    rtype

    bool

static GetStandardPriority()
  • Returns the standard priority of the shape aShap having the type aType. This priority is passed to a StdSelect_BRepOwner object. You can use the function Load to modify the selection priority of an owner to make one entity more selectable than another one.
    param theShape

    type theShape

    TopoDS_Shape

    param theType

    type theType

    TopAbs_ShapeEnum

    rtype

    int

static Load()
  • Decomposition of <aShape> into sensitive entities following a mode of decomposition <aType>. These entities are stored in <aSelection>. BrepOwners are created to store the identity of the picked shapes during the selection process. In those BRepOwners is also stored the original shape. But One can’t get the selectable object which was decomposed to give the sensitive entities. maximal parameter is used for infinite objects, to limit the sensitive Domain…. If AutoTriangulation = True, a Triangulation will be computed for faces which have no existing one. if AutoTriangulation = False the old algorithm will be called to compute sensitive entities on faces.
    param aSelection

    type aSelection

    SelectMgr_Selection

    param aShape

    type aShape

    TopoDS_Shape

    param aType

    type aType

    TopAbs_ShapeEnum

    param theDeflection

    type theDeflection

    float

    param theDeviationAngle

    type theDeviationAngle

    float

    param AutoTriangulation

    default value is Standard_True

    type AutoTriangulation

    bool

    param aPriority

    default value is -1

    type aPriority

    int

    param NbPOnEdge

    default value is 9

    type NbPOnEdge

    int

    param MaximalParameter

    default value is 500

    type MaximalParameter

    float

    rtype

    void* Same functionnalities ; the only difference is that the selectable object from which the selection comes is stored in each Sensitive EntityOwner; decomposition of <aShape> into sensitive entities following a mode of decomposition <aType>. These entities are stored in <aSelection> The Major difference is that the known users are first inserted in the BRepOwners. the original shape is the last user… (see EntityOwner from SelectBasics and BrepOwner)…

    param aSelection

    type aSelection

    SelectMgr_Selection

    param Origin

    type Origin

    SelectMgr_SelectableObject

    param aShape

    type aShape

    TopoDS_Shape

    param aType

    type aType

    TopAbs_ShapeEnum

    param theDeflection

    type theDeflection

    float

    param theDeviationAngle

    type theDeviationAngle

    float

    param AutoTriangulation

    default value is Standard_True

    type AutoTriangulation

    bool

    param aPriority

    default value is -1

    type aPriority

    int

    param NbPOnEdge

    default value is 9

    type NbPOnEdge

    int

    param MaximalParameter

    default value is 500

    type MaximalParameter

    float

    rtype

    void

static PreBuildBVH()
  • Traverses the selection given and pre-builds BVH trees for heavyweight sensitive entities containing more than BVH_PRIMITIVE_LIMIT (defined in .cxx file) sub-elements.
    param theSelection

    type theSelection

    SelectMgr_Selection

    rtype

    void

property thisown

The membership flag

class StdSelect_EdgeFilter(*args)

Bases: OCC.Core.SelectMgr.SelectMgr_Filter

  • Constructs an edge filter object defined by the type of edge Edge.
    param Edge

    type Edge

    StdSelect_TypeOfEdge

    rtype

    None

static DownCast(t)
SetType()
  • Sets the type of edge aNewType. aNewType is to be highlighted in selection.
    param aNewType

    type aNewType

    StdSelect_TypeOfEdge

    rtype

    None

Type()
  • Returns the type of edge to be highlighted in selection.
    rtype

    StdSelect_TypeOfEdge

property thisown

The membership flag

class StdSelect_FaceFilter(*args)

Bases: OCC.Core.SelectMgr.SelectMgr_Filter

  • Constructs a face filter object defined by the type of face aTypeOfFace.
    param aTypeOfFace

    type aTypeOfFace

    StdSelect_TypeOfFace

    rtype

    None

static DownCast(t)
SetType()
  • Sets the type of face aNewType. aNewType is to be highlighted in selection.
    param aNewType

    type aNewType

    StdSelect_TypeOfFace

    rtype

    None

Type()
  • Returns the type of face to be highlighted in selection.
    rtype

    StdSelect_TypeOfFace

property thisown

The membership flag

class StdSelect_IndexedDataMapOfOwnerPrs(*args)

Bases: object

Add()
Assign()
ChangeFromIndex()
ChangeFromKey()
ChangeSeek()
Clear()
Contains()
Exchange()
FindFromIndex()
FindFromKey()
FindIndex()
FindKey()
ReSize()
RemoveFromIndex()
RemoveKey()
RemoveLast()
Seek()
Set()
Size()
Substitute()
Swap()
begin()
cbegin()
cend()
end()
property thisown

The membership flag

class StdSelect_Prs(*args)

Bases: OCC.Core.Graphic3d.Graphic3d_Structure

Parameters

aStructureManager

type aStructureManager

Graphic3d_StructureManager

rtype

None

static DownCast(t)
Manager()
Return type

opencascade::handle<Graphic3d_StructureManager>

property thisown

The membership flag

class StdSelect_Shape(*args)

Bases: OCC.Core.PrsMgr.PrsMgr_PresentableObject

Parameters

theShape

type theShape

TopoDS_Shape

param theDrawer

default value is opencascade::handle<Prs3d_Drawer>()

type theDrawer

Prs3d_Drawer

rtype

None

Compute()
Parameters

aPresentationManager

type aPresentationManager

PrsMgr_PresentationManager3d

param aPresentation

type aPresentation

Prs3d_Presentation

param aMode

default value is 0

type aMode

int

rtype

None* computes the presentation according to a point of view given by <aProjector>. To be Used when the associated degenerated Presentations have been transformed by <aTrsf> which is not a Pure Translation. The HLR Prs can’t be deducted automatically WARNING :<aTrsf> must be applied to the object to display before computation !!!

param aProjector

type aProjector

Prs3d_Projector

param aTrsf

type aTrsf

Geom_Transformation

param aPresentation

type aPresentation

Prs3d_Presentation

rtype

void

static DownCast(t)
Shape()
Return type

TopoDS_Shape:param theShape: :type theShape: TopoDS_Shape :rtype: None

property thisown

The membership flag

class StdSelect_ShapeTypeFilter(*args)

Bases: OCC.Core.SelectMgr.SelectMgr_Filter

  • Constructs a filter object defined by the shape type aType.
    param aType

    type aType

    TopAbs_ShapeEnum

    rtype

    None

static DownCast(t)
Type()
  • Returns the type of shape selected by the filter.
    rtype

    TopAbs_ShapeEnum

property thisown

The membership flag

class StdSelect_ViewerSelector3d(*args)

Bases: object

  • Constructs an empty 3D selector object.
    rtype

    None

ClearSensitive()
Parameters

theView

type theView

V3d_View

rtype

None

DisplaySensitive()
  • Displays sensitives in view <theView>.
    param theView

    type theView

    V3d_View

    rtype

    None:param theSel:

    type theSel

    SelectMgr_Selection

    param theTrsf

    type theTrsf

    gp_Trsf

    param theView

    type theView

    V3d_View

    param theToClearOthers

    default value is Standard_True

    type theToClearOthers

    bool

    rtype

    None

static DownCast(t)
Pick()
  • Picks the sensitive entity at the pixel coordinates of the mouse <theXPix> and <theYPix>. The selector looks for touched areas and owners.
    param theXPix

    type theXPix

    int

    param theYPix

    type theYPix

    int

    param theView

    type theView

    V3d_View

    rtype

    None* Picks the sensitive entity according to the minimum and maximum pixel values <theXPMin>, <theYPMin>, <theXPMax> and <theYPMax> defining a 2D area for selection in the 3D view aView.

    param theXPMin

    type theXPMin

    int

    param theYPMin

    type theYPMin

    int

    param theXPMax

    type theXPMax

    int

    param theYPMax

    type theYPMax

    int

    param theView

    type theView

    V3d_View

    rtype

    None* pick action - input pixel values for polyline selection for selection.

    param thePolyline

    type thePolyline

    TColgp_Array1OfPnt2d

    param theView

    type theView

    V3d_View

    rtype

    None

PixelTolerance()
  • Returns the pixel tolerance.
    rtype

    int

SetPixelTolerance()
  • Sets the pixel tolerance <theTolerance>.
    param theTolerance

    type theTolerance

    int

    rtype

    None

ToPixMap()
  • Dump of detection results into image. This method performs axis picking for each pixel in the image and generates a color depending on picking results and selection image type. @param theImage result image, should be initialized @param theView 3D view defining camera position @param theType type of image to define @param thePickedIndex index of picked entity (1 means topmost)
    param theImage

    type theImage

    Image_PixMap

    param theView

    type theView

    V3d_View

    param theType

    type theType

    StdSelect_TypeOfSelectionImage

    param thePickedIndex

    default value is 1

    type thePickedIndex

    int

    rtype

    bool

property thisown

The membership flag

class SwigPyIterator(*args, **kwargs)

Bases: object

advance()
copy()
decr()
distance()
equal()
incr()
next()
previous()
property thisown

The membership flag

value()
class stdselect

Bases: object

static SetDrawerForBRepOwner()
  • puts The same drawer in every BRepOwner Of SensitivePrimitive Used Only for hilight Of BRepOwner…
    param aSelection

    type aSelection

    SelectMgr_Selection

    param aDrawer

    type aDrawer

    Prs3d_Drawer

    rtype

    void

property thisown

The membership flag